; v.1.00
; copyright (c) W. Lenerz 1996
; GET_STR
; entry				exit
; D0				error or 0
; D1				length of string
; A1				points to string
; A3 pointer to start of parameter	A3 preserved
;
; all other registers presered, condition codes set on exit
; this will only work in Sbasic or a compiled program

	section	text

	XDEF	getstr


getstr	MOVE.B	1(A6,A3.L),D0	; type byte
	ANDI.B	#$F,D0
	SUBQ.B	#1,D0		; was it a string?
	BEQ.S	is_str		; yes
; if it isn't a string, get name from name area!
no_str	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.W	2(A6,A3.L),D0	; point to name table
	LSL.L	#3,D0		; * 8 (eight bytes per entry)
	ADD.L	$18(A6),D0	; add offset
	MOVE.W	2(A6,D0.L),D1	; point to value now
	BEQ.S	errout
	MOVE.L	D1,A1
	ADD.L	$20(A6),A1	; add offset
	ADD.L	A6,A1		; absolute value now
	MOVEQ	#0,D1
	MOVE.B	(A1)+,D1		; length of string
	BRA.S	com

is_str	MOVE.L	4(A6,A3.L),A1	; point to value now
	MOVE.W	(A1)+,D1		; length
com	BEQ.S	errout		; if 0: complain
out	MOVEQ	#0,D0
	RTS
errout	MOVEQ	#-15,D0
	RTS

	END
