; function mkstring for Prowess SBasic Interface
; v. 1.01
; (c) copyright W. Lenerz 1996
;



****************************************************************************
*
* syntax:  result$=MKSTRING(address)
*
* converts a C string starting at address into a QL string & returns it to basic
*
* result$= returned string
*
* address= the address where the C string starts
*
*****************************************************************************

	section	text
	xdef	mkstring$

	xref	rt_str		; returns string to basic (lib_returnparams)
	xref	get_para		; gets one long integer (prowess_asm_getparams)

mkstring$ BSR	get_para		; get one long integer
	MOVE.L	(A6,A1.L),A4	; point to address
	MOVE.L	A4,A3		; point to start of string
	MOVEQ	#0,D4		; length of string
loop	TST.B	(A4)+		; end of string reached?
	BEQ.S	foundit		; yes->...
	ADDQ.W	#1,D4		; no, so increase length
	BRA.S	loop
foundit	BRA	rt_str		; return string to sbasic now
	end
